# Announce: Rakudo Perl 6 compiler, Development Release #62 ("Singapore")

On behalf of the Rakudo development team, I'm proud to announce the
March 2013 release of Rakudo Perl #62 "Singapore". Rakudo is an
implementation of Perl 6 on the Parrot Virtual Machine (see
<http://www.parrot.org>). The tarball for this release is available
from <http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^1] --- it's announcing a new release of the compiler
only.  For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, with each
release named after a Perl Mongers group. The March 2013 release is
code-named after Singapore.pm.

Some of the changes in this release are outlined below:

* Rakudo warns when pure expressions are used in sink context
* .substr(...) now correctly accepts whatever-star closures
* Implemented shellwords postcircumfix (%h<< $x 'foo bar' >>)
* Defining operators spelled like the empty string is now illegal
* Array interpolations now properly do LTM
* Autothread "none" and "all" junctions before "any" and "one"
* Helpful error if you write "else if"/"elif" instead of "elsif"
* Throw exception if a Range is used as a Range endpoint
* Corrected argument order in IO.seek

This is only some of the changes in this release. For a more
detailed list, see "docs/ChangeLog".

The development team thanks all of our contributors and sponsors for
making Rakudo Perl possible, as well as those people who worked on
Parrot, the Perl 6 test suite and the specification.

The following people contributed to this release:

Jonathan Worthington, kboga, Tobias Leich, Moritz Lenz, Patrick R. Michaud,
Timo Paulssen, Carl Mäsak, Tadeusz Sośnierz, Gerhard R, thundergnat,
TimToady

If you would like to contribute, see <http://rakudo.org/how-to-help>,
ask on the <perl6-compiler@perl.org> mailing list, or ask on IRC
\#perl6 on freenode.

The next release of Rakudo (#63), is scheduled for April 18, 2013.
A list of the other planned release dates and code names for future
releases is available in the "docs/release_guide.pod" file. In
general, Rakudo development releases are scheduled to occur soon after
each Parrot monthly release.  Parrot releases the third Tuesday of
each month.

On behalf of the development team, I encourage you to try the new release,
to live life to its fullest, to cherish each moment, and to have fun.

[^1]: What's the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Nothing else.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, the most recent incarnation of the "Using
Perl 6" book, and other software that can be used with the Rakudo
compiler to enhance its utility.  Rakudo Star is meant for early
adopters who wish to explore what's possible with Rakudo Perl 6 and
provide feedback on what works, what doesn't, and what else they
would like to see included in the distribution.
