# Announce: Rakudo Perl 6 compiler, Development Release #64 ("Austin")

On behalf of the Rakudo development team, I'm proud to announce the
May 2013 release of Rakudo Perl #64 "Austin". Rakudo is an
implementation of Perl 6 on the Parrot Virtual Machine (see
<http://www.parrot.org>). The tarball for this release is available
from <http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^1] --- it's announcing a new release of the compiler
only.  For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, with each
release named after a Perl Mongers group. The May 2013 release is
code-named after Austin.pm.
You'll see that this release is pure destiny. Its release number is 2**6,
its codename has 6 chars, it is named after the place where the next YAPC::NA
will happen on the sixth month of this year, a year with a crossfoot of 6.


Some of the changes in this release are outlined below:

* IO::Spec, a port of Perl 5's File::Spec
* speedup of repeated shifts of large lists and arrays by 70%+
* regex special characters can be used as delimiters
* allow slice with :exists adverb on hashes
* fix regex interpolation slowdown
* fix exporting of subroutines
* fix reporting of errors in gather/take.
* added 125 extra opening/closing bracket-pairs
* fix build failure on SPARC and PowerPC
* underlying nqp layer supports parrot and JVM as backend, in preparation
  for JVM support in a future Rakudo release

This is only some of the changes in this release. For a more
detailed list, see "docs/ChangeLog".

The development team thanks all of our contributors and sponsors for
making Rakudo Perl possible, as well as those people who worked on
Parrot, the Perl 6 test suite and the specification.

The following people contributed to this release:

Brent Laabs, Moritz Lenz, Patrick R. Michaud, Tobias Leich, Jonathan Worthington,
Will "Coke" Coleda, Elizabeth Mattijsen, dagurval, Carl Mäsak, Solomon Foster,
Larry Wall, Tadeusz Sośnierz, Timo Paulssen, Arne Skjærholt, Timothy Totten

If you would like to contribute, see <http://rakudo.org/how-to-help>,
ask on the <perl6-compiler@perl.org> mailing list, or ask on IRC
\#perl6 on freenode.

The next release of Rakudo (#65), is scheduled for June 20, 2013.
A list of the other planned release dates and code names for future
releases is available in the "docs/release_guide.pod" file. In
general, Rakudo development releases are scheduled to occur soon after
each Parrot monthly release.  Parrot releases the third Tuesday of
each month.

On behalf of the development team, I encourage you to try the new release.
Take a deep breath. Write some new code. Don't forget to be awesome.


[^1]: What's the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Nothing else.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, the most recent incarnation of the "Using
Perl 6" book, and other software that can be used with the Rakudo
compiler to enhance its utility.  Rakudo Star is meant for early
adopters who wish to explore what's possible with Rakudo Perl 6 and
provide feedback on what works, what doesn't, and what else they
would like to see included in the distribution.
