# Announce: Rakudo Perl 6 compiler, Development Release #69 ("Roederbergweg")

On behalf of the Rakudo development team, I'm happy to announce the
October 2013 release of Rakudo Perl #69 "Roederbergweg". Rakudo is an
implementation of Perl 6 on the Parrot Virtual Machine and the Java Virtual
Machine. The tarball for this release is available from
<http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^1] --- it's announcing a new release of the compiler
only.  For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, with each
release named after a Perl Mongers group. The October 2013 release is
code-named after Roederbergweg.pm, a Perl Mongers group very near the recent
Perl 6 Internals Workshop

Some of the changes in this release are outlined below:

+ postcircumfix {} and [] are now implemented as multi subs rather than
  multi methods.  This should allow for better optimization in the future.
+ Add support for "is deprecated", making it easy for early adopters
  to stay current.
+ Track multiple spec changes for various container classes.
+ Greatly reduce object creation during Regex parsing.
+ Various portability fixes.

These are only some of the changes in this release. For a more
detailed list, see "docs/ChangeLog".

The development team thanks all of our contributors and sponsors for
making Rakudo Perl possible, as well as those people who worked on
Parrot, the Perl 6 test suite and the specification.

The following people contributed to this release:

Jonathan Worthington, Arne Skjærholt, Timo Paulssen, Carl Masak, Moritz Lenz, Tobias Leich, Alexander Moquin, Patrick R. Michaud, Elizabeth Mattijsen, grondilu, Jonathan Scott Duff, Will "Coke" Coleda

If you would like to contribute, see <http://rakudo.org/how-to-help>,
ask on the <perl6-compiler@perl.org> mailing list, or ask on IRC
\#perl6 on freenode.

The next release of Rakudo (#70), is scheduled for November 21, 2013.
A list of the other planned release dates and code names for future
releases is available in the "docs/release_guide.pod" file. A Rakudo
development release occurs soon after each Parrot monthly release is
scheduled to occur.  Parrot usually releases the third Tuesday of
each month.

On behalf of the development team, I encourage you to try the new release,
step out of your comfort zone, and get a library card.

[^1]: What's the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Nothing else.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, a module installer, the most recent
incarnation of the "Using Perl 6" book, and other software that can
be used with the Rakudo compiler to enhance its utility.  Rakudo Star
is meant for early adopters who wish to explore what's possible with
Rakudo Perl 6 and provide feedback on what works, what doesn't, and
what else they would like to see included in the distribution.
