# Announce: Rakudo Perl 6 compiler, Development Release #70 ("Malmö")

On behalf of the Rakudo development team, I'm happy to announce the
November 2013 release of Rakudo Perl #70 "Malmö". Rakudo is an
implementation of Perl 6 on the Parrot Virtual Machine and the Java Virtual
Machine. The tarball for this release is available from
<http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^1] --- it's announcing a new release of the compiler
only.  For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, with each
release named after a Perl Mongers group. The November 2013 release is
code-named after Malmö, from which this release has been launched.

Some of the changes in this release are outlined below:

+ Many concurrency primitives harmonized with new S17, but still pretty fluid
+ Refactored build system that allows building rakudo on rakudo/JVM in the same place
+ Order::Increase/Decrease are deprecated.  Please use Order::Less/More.
+ Leading whitespace is ignored for :sigspace
+ Better null pattern detection in regexes
+ improved run()/shell(), these return Proc::Status-objects now
+ The "gethostname" function implemented
+ Performance optimization: unfold junctions in 'when' clauses
+ various other bug fixes, optimisations and additional tests

These are only some of the changes in this release. For a more
detailed list, see "docs/ChangeLog".

The development team thanks all of our contributors and sponsors for
making Rakudo Perl possible, as well as those people who worked on
Parrot, the Perl 6 test suite and the specification.

The following people contributed to this release:

Moritz Lenz, Tobias Leich, Jonathan Worthington, Timo Paulssen,
Will "Coke" Coleda, Mouq, Brian Gernhardt, Arne Skjærholt, L. Grondin,
Geoffrey Broadwell, Steve Mynott, Andrew Egeler, Elizabeth Mattijsen

If you would like to contribute, see <http://rakudo.org/how-to-help>,
ask on the <perl6-compiler@perl.org> mailing list, or ask on IRC
\#perl6 on freenode.

The next release of Rakudo (#71), is scheduled for December 19, 2013.
A list of the other planned release dates and code names for future
releases is available in the "docs/release_guide.pod" file. A Rakudo
development release occurs soon after each Parrot monthly release is
scheduled to occur.  Parrot usually releases the third Tuesday of
each month.

On behalf of the development team, I encourage you to try the new release,
step out of your comfort zone, and get a library card.

[^1]: What's the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Nothing else.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, a module installer, the most recent
incarnation of the "Using Perl 6" book, and other software that can
be used with the Rakudo compiler to enhance its utility.  Rakudo Star
is meant for early adopters who wish to explore what's possible with
Rakudo Perl 6 and provide feedback on what works, what doesn't, and
what else they would like to see included in the distribution.
