# Announce: Rakudo Perl 6 compiler, Development Release #73 ("Karlsruhe.pm")

On behalf of the Rakudo development team, I'm happy to announce the
February 2014 release of Rakudo Perl 6 #73 "Karlsruhe.pm". Rakudo is an
implementation of Perl 6 on the Parrot Virtual Machine, the Java Virtual
Machine and the Moar Virtual Machine[^1]. The tarball for this release
is available from <http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^2] --- it's announcing a new release of the compiler
only.  For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, with each
release named after a Perl Mongers group. This time it's the Perl
Mongers group of Karlsruhe, Germany - where Timo Paulssen has been
advertising Perl 6 to the other group members incessantly.

Some of the changes in this release are outlined below:

+ The JVM now has full NativeCall support based on JNA.
+ The core of Rakudo::Debugger is now part of Rakudo
  itself and works across all backends.
+ "make" no longer itemizes its arguments.
+ for-loops at the statementlist level are now sunk by default.
+ better parsing of unspaces and formatting codes inside Pod blocks.
+ lots of improvements to the MoarVM backend
  including sockets and pipe opening.

These are only some of the changes in this release. For a more
detailed list, see "docs/ChangeLog".

The development team thanks all of our contributors and sponsors for
making Rakudo Perl possible, as well as those people who worked on
Parrot, the Perl 6 test suite, MoarVM and the specification.

The following people contributed to this release:

Jonathan Worthington, Tobias Leich, Mouq, Moritz Lenz, Timo Paulssen,
Carl Masak, Larry Wall, Rob Hoelz, Jonathan Scott Duff, Matthew Wilson,
Pepe Schwarz, Will "Coke" Coleda, Steve Mynott, raydiak, Geoffrey Broadwell,
itz_, and Nicholas Clark.

If you would like to contribute, see <http://rakudo.org/how-to-help>,
ask on the <perl6-compiler@perl.org> mailing list, or ask on IRC
\#perl6 on freenode.

The next release of Rakudo (#74), is scheduled for March 20, 2014.
A list of the other planned release dates and code names for future
releases is available in the "docs/release_guide.pod" file. A Rakudo
development release typically occurs a few days (often two) after the
third Tuesday of each month.

On behalf of the development team, I encourage you to enjoy the new release,
try awesome stuff, have the appropriate amount of fun, and get back to us
with feedback.

[^1]: See <http://moarvm.org/>

[^2]: What's the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Nothing else.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, a module installer, the most recent
incarnation of the "Using Perl 6" book, and other software that can
be used with the Rakudo compiler to enhance its utility.  Rakudo Star
is meant for early adopters who wish to explore what's possible with
Rakudo Perl 6 and provide feedback on what works, what doesn't, and
what else they would like to see included in the distribution.
