# Announce: Rakudo Perl 6 compiler, Development Release #77 ("Gdańsk")

On behalf of the Rakudo development team, I'm happy to announce the
June 2014 release of Rakudo Perl 6 #77 "Gdańsk". Rakudo is an
implementation of Perl 6 on the Parrot Virtual Machine, the Java Virtual
Machine and the Moar Virtual Machine[^1]. The tarball for this release
is available from <http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^2] --- it's announcing a new release of the compiler
only. For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, with each
release named after a Perl Mongers group. We hope there is a Perl Mongers
group in Gdańsk after meeting Perl developers from Gdańsk during
the PLPW this year. They proposed to organize PLPW next year.

Some of the changes in this release are outlined below:

+ an initial implementation of S11 (Compilation Units) is now available
+ $*DISTRO now works correctly on OS X (with name "macosx")
+ $*KERNEL now works correctly on OS X (with name "darwin")
+ initial implementation of $*USER and $*GROUP
+ IO::Socket::Async now also works on JVM
+ optimization:
    + .IO.{d,s,z} are now about 40% faster and return Failure if path doesn't exist
    + :a(:$b) and attributive binding
    + IO::Path.contents
    + push, unshift and comb
    + say, note
    + no-args case of @foo>>.bar
+ implement :42nd colonpair syntax


These are only some of the changes in this release. For a more
detailed list, see "docs/ChangeLog".

The development team thanks all of our contributors and sponsors for
making Rakudo Perl possible, as well as those people who worked on
Parrot, the Perl 6 test suite, MoarVM and the specification.

The following people contributed to this release:


Elizabeth Mattijsen, Tobias Leich, Jonathan Worthington,
Timo Paulssen, Donald Hunter, Pepe Schwarz, Moritz Lenz,
Alexander Moquin, Filip Sergot, Rob Hoelz, Reini Urban, Geoff Broadwell

If you would like to contribute, see <http://rakudo.org/how-to-help>,
ask on the <perl6-compiler@perl.org> mailing list, or ask on IRC
\#perl6 on freenode.

The next release of Rakudo (#78), is scheduled for July 17, 2014.
A list of the other planned release dates and code names for future
releases is available in the "docs/release_guide.pod" file. A Rakudo
development release typically occurs a few days (often two) after the
third Tuesday of each month.

On behalf of the development team, I encourage you to enjoy the new release,
try awesome stuff, have the appropriate amount of fun, and get back to us
with feedback.

[^1]: See <http://moarvm.org/>

[^2]: What's the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Nothing else.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, a module installer, the most recent
incarnation of the "Using Perl 6" book, and other software that can
be used with the Rakudo compiler to enhance its utility.  Rakudo Star
is meant for early adopters who wish to explore what's possible with
Rakudo Perl 6 and provide feedback on what works, what doesn't, and
what else they would like to see included in the distribution.
