# Announce: Rakudo Perl 6 compiler, Development Release #78 ("Sofia")

On behalf of the Rakudo development team, I'm happy to announce the
July 2014 release of Rakudo Perl 6 #78 "Sofia". Rakudo is an
implementation of Perl 6 on the Parrot Virtual Machine, the Java Virtual
Machine and the Moar Virtual Machine[^1]. The tarball for this release
is available from <http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^2] --- it's announcing a new release of the compiler
only. For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, with each release
named after a Perl Mongers group. This release is named after Sofia, the
city where the YAPC::EU will take place in a little bit more than a month.

Some of the changes in this release are outlined below:

+ Cool.eval and eval() are now removed
+ assigning a single itemized hash to a hash is now DEPRECATED (my %h = {...})
+ .hash now turns an itemized hash into a hash
+ subbuf-rw specced and implemented
+ minute value is optional in Timezone offsets in DateTime.new(), also a colon
  to delimit hours/minutes is now optional
+ the tr/// operator is implemented and has the proper return value
+ improved string handling for MoarVM backend
+ re-arranged infixish actions to support [[*]]= etc
+ all backends now allow C pointer arithmetic and casting of pointers to Perl 6 types
  (this funtionality is exposed by NativeCall)
+ fixed 'fail' so it also prints a backtrace
+ removed hack for $Inf/$NaN: constants Inf/NaN are exposed since a while
+ made initial/max threads introspectable
+ make .WHICH also work on type objects


These are only some of the changes in this release. For a more
detailed list, see "docs/ChangeLog".

The development team thanks all of our contributors and sponsors for
making Rakudo Perl possible, as well as those people who worked on
Parrot, the Perl 6 test suite, MoarVM and the specification.

The following people contributed to this release:


Elizabeth Mattijsen, Jonathan Worthington, Tobias Leich, Timo Paulssen,
Filip Sergot, Carlin, Will Coleda, Pepe Schwarz, Will Coleda, Carl Masak,
Alexander Moquin, Andrew Egeler, Jonathan Scott Duff, Moritz Lenz

If you would like to contribute, see <http://rakudo.org/how-to-help>,
ask on the <perl6-compiler@perl.org> mailing list, or ask on IRC
\#perl6 on freenode.

The next release of Rakudo (#79), is scheduled for August 21, 2014.
A list of the other planned release dates and code names for future
releases is available in the "docs/release_guide.pod" file. A Rakudo
development release typically occurs a few days (often two) after the
third Tuesday of each month.

On behalf of the development team, I encourage you to enjoy the new release,
try awesome stuff, have the appropriate amount of fun, and get back to us
with feedback.

[^1]: See <http://moarvm.org/>

[^2]: What's the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Nothing else.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, a module installer, the most recent
incarnation of the "Using Perl 6" book, and other software that can
be used with the Rakudo compiler to enhance its utility.  Rakudo Star
is meant for early adopters who wish to explore what's possible with
Rakudo Perl 6 and provide feedback on what works, what doesn't, and
what else they would like to see included in the distribution.
