# Announce: Rakudo Perl 6 compiler, Development Release #81 ("Linz")

On behalf of the Rakudo development team, I'm happy to announce the
Octover 2014 release of Rakudo Perl 6 #81 "Linz". Rakudo is an
implementation of Perl 6 on the Moar Virtual Machine[^1], the Java Virtual
Machine and the Parrot Virtual Machine. The tarball for this release
is available from <http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^2] --- it's announcing a new release of the compiler
only. For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, with each
release named after a Perl Mongers group. This release is named after
Linz, because I really wanted to name this release "Salzburg" where the
Austrian Perl Workshop was recently held, but there's no Salzburg.pm and
Linz.pm was the closest Austria Perl Mongers group. :)

Some of the changes in this release are outlined below:

- strict pragma implemented and turned off for one-liners
- Method form of .exists and .delete have finally been removed
- Supply.lines/words and IO::Handle.words implemented, Str.words now lazy
- Scoped directory manipulation: indir, tmpdir, homedir
- Better deprecation messages
- Various performance improvements

These are only some of the changes in this release. For a more
detailed list, see "docs/ChangeLog".

This is last release of Rakudo to support parrot without ICU. Future
versions of Rakudo will require ICU support in the Parrot backend.
Note: while this release does not require ICU support in Parrot, some
tests in the standard Perl 6 test suite will nonetheless fail without it.

The development team thanks all of our contributors and sponsors for
making Rakudo Perl possible, as well as those people who worked on
Parrot, the Perl 6 test suite, MoarVM and the specification.

The following people contributed to this release:

Elizabeth Mattijsen, Jonathan Worthington, Tobias Leich, Moritz Lenz,
Jonathan Scott Duff, Christian Bartolomäus, Brad Gilbert, Solomon
Foster, Larry Wall, Pepe Schwarz, Timo Paulssen, Mikhail Khorkov,
Will "Coke" Coleda, abraxxa, skids, Rob Hoelz, leont, laben, Patrick
R. Michaud

If you would like to contribute, see <http://rakudo.org/how-to-help>,
ask on the <perl6-compiler@perl.org> mailing list, or ask on IRC
\#perl6 on freenode.

The next release of Rakudo (#82), is scheduled for November 20, 2014.
A list of the other planned release dates and code names for future
releases is available in the "docs/release_guide.pod" file. A Rakudo
development release typically occurs a few days (often two) after the
third Tuesday of each month.

The development team appreciates feedback! If you're using Rakudo, do
get back to us. Questions, comments, suggestions for improvements, cool
discoveries, incredible hacks, or any other feedback -- get in touch with
us through (the above-mentioned) mailing list of IRC channel. Enjoy!

[^1]: See <http://moarvm.org/>

[^2]: What's the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Nothing else.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, a module installer, the most recent
incarnation of the "Using Perl 6" book, and other software that can
be used with the Rakudo compiler to enhance its utility.  Rakudo Star
is meant for early adopters who wish to explore what's possible with
Rakudo Perl 6 and provide feedback on what works, what doesn't, and
what else they would like to see included in the distribution.
