# Announce: Rakudo Perl 6 compiler, Development Release #84 (“Gotanda”)

On behalf of the Rakudo development team, I’m happy to announce the
January 2015 release of Rakudo Perl 6 #84 “Gotanda”. Rakudo is an
implementation of Perl 6 on the Moar Virtual Machine[^1], the Java Virtual
Machine and the Parrot Virtual Machine[^2]. The tarball for this release
is available from <http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^3] --- it’s announcing a new release of the compiler
only. For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, with each
release named after a Perl Mongers group. This release is named after
Gotanda.pm

Some of the changes in this release are outlined below:

These are only some of the changes in this release. For a more
detailed list, see “docs/ChangeLog”.

INCOMPATIBLE CHANGES:
+ None this release

Other notable changes:
+ All deprecated features will be removed with 6.0.0 (sometime in 2015)
+ Startup on the JVM has improved by 20%
+ Many improvements to Java interop for the JVM backend
+ New simple way of creating an object hash: :{}
+ Substitution now supports assignment meta-op, e.g. s[\d+] += 2
+ Many memory and CPU optimizations
+ Supply.for deprecated in favour of Supply.from-list

The development team thanks all of our contributors and sponsors for
making Rakudo Perl possible, as well as those people who worked on
Parrot, the Perl 6 test suite, MoarVM and the specification.

The following people contributed to this release:

Elizabeth Mattijsen, Moritz Lenz, Pepe Schwarz, Jonathan Worthington, Larry Wall,
Tobias Leich, ab5tract, Christian Bartolomäus, Rob Hoelz, Donald Hunter, Timo Paulssen,
raydiak, Geoffrey Broadwell, Alexander Moquin, Yun SangHo, skids, Lucas Buchala,
Will Coleda, Solomon Foster, Steve Mynott, ugexe, Carl Mäsak, pmurias, woolfy

If you would like to contribute, see <http://rakudo.org/how-to-help>,
ask on the <perl6-compiler@perl.org> mailing list, or ask on IRC
\#perl6 on freenode.

The next release of Rakudo (#85), is scheduled for 19 February 2015.
A list of the other planned release dates and code names for future
releases is available in the “docs/release_guide.pod” file. A Rakudo
development release typically occurs a few days (often two) after the
third Tuesday of each month.

The development team appreciates feedback! If you’re using Rakudo, do
get back to us. Questions, comments, suggestions for improvements, cool
discoveries, incredible hacks, or any other feedback -- get in touch with
us through (the above-mentioned) mailing list of IRC channel. Enjoy!

[^1]: See <http://moarvm.org/>

[^2]: See <http://parrot.org/>

[^3]: What’s the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Nothing else.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, a module installer, the most recent
incarnation of the “Using Perl 6” book, and other software that can
be used with the Rakudo compiler to enhance its utility.  Rakudo Star
is meant for early adopters who wish to explore what’s possible with
Rakudo Perl 6 and provide feedback on what works, what doesn’t, and
what else they would like to see included in the distribution.
