# Announce: Rakudo Perl 6 compiler, Development Release #89 ("Salt Lake")

On behalf of the Rakudo development team, I'm happy to announce the June
2015 release of Rakudo Perl 6 #89 "Salt Lake". Rakudo is an implementation of
Perl 6 on the Moar Virtual Machine[^1] and the Java Virtual Machine. The
tarball for this release is available from <http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^2] --- it's announcing a new release of the compiler
only. For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, with each
release named after a Perl Mongers group. This month's release is named after
Salt Lake City, where this year's YAPC::NA happened.

Some of the changes in this release are outlined below:

* Lexical pragma 'use trace' now outputs statements on STDERR
* $=finish now contains text after first =finish/=for finish/=begin finish
* Added :as named param to .classify / .categorize
* EVALFILE added, for evalling source in a file
* Implemented 'quietly' statement prefix to prevent warnings being issued
* DateTime default timezone format is now +HH:MM (used to be +HHMM)
* "".IO / IO::Path.new("") no longer legal, use "." for current dir
* next/last/redo don't allow expressions to be evaluated anymore
* sign(NaN)/NaN.sign is now NaN
* Stubbed-out code (via .../!!!) no longer results in X::AdHoc

These are only some of the changes in this release. For a more
detailed list, see "docs/ChangeLog".

The development team thanks all of our contributors and sponsors for
making Rakudo Perl possible, as well as those people who worked on
Parrot, the Perl 6 test suite, MoarVM and the specification.

The following people contributed to this release:

Elizabeth Mattijsen, Tobias Leich, Jonathan Worthington, Timo Paulssen, Rob
Hoelz, Christian Bartolomäus, Will "Coke" Coleda, Bart Wiegmans, Larry Wall,
Moritz Lenz, Justin DeVuyst, Steve Mynott, Carl Masak, Solomon Foster, cygx,
smls, Alexander Moquin, Jonathan Stowe, Brent Laabs, Dagur Valberg Johannsson,
Sam S

If you would like to contribute, see <http://rakudo.org/how-to-help>,
ask on the <perl6-compiler@perl.org> mailing list, or ask on IRC #perl6
on freenode.

The next release of Rakudo (#90), is scheduled for 23 July 2015.
A list of the other planned release dates and code names for future
releases is available in the "docs/release_guide.pod" file. A Rakudo
development release typically occurs a few days (often two) after the
third Tuesday of each month.

The development team appreciates feedback! If you're using Rakudo, do
get back to us. Questions, comments, suggestions for improvements, cool
discoveries, incredible hacks, or any other feedback -- get in touch with
us through (the above-mentioned) mailing list or IRC channel. Enjoy!

[^1]: See <http://moarvm.org/>

[^2]: What's the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Not much more.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, a module installer, the most recent
incarnation of the "Using Perl 6" book, and other software that can
be used with the Rakudo compiler to enhance its utility.  Rakudo Star
is meant for early adopters who wish to explore what's possible with
Rakudo Perl 6 and provide feedback on what works, what doesn't, and
what else they would like to see included in the distribution.
