# Announce: Rakudo Perl 6 compiler, Development Release #90 ("Prague")

On behalf of the Rakudo development team, I'm happy to announce the July
2015 release of Rakudo Perl 6 #90 "Prague". Rakudo is an implementation of
Perl 6 on the Moar Virtual Machine[^1] and the Java Virtual Machine. The
tarball for this release is available from <http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^2] --- it's announcing a new release of the compiler
only. For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, with each
release named after a Perl Mongers group. This month's release is named after
Prague, new home to one of the Rakudo core developers.

Some of the changes in this release are outlined below:

* Cool.substr(-rw) and &substr(-rw) now also accept a Range
* Added trait "is required" on class attributes
* &?ROUTINE and &?BLOCK
* &words implemented (to completement .words)
* Numeric comparison ops (== > etc) for DateTimes
* samewith() now also works in subs
* Calling the .clone method with alternate values no longer changes original
* .grep and &grep now consume multiple elements for many-param blocks
* ENTER phaser now can be used as an r-value

These are only some of the changes in this release. For a more
detailed list, see "docs/ChangeLog".

The development team thanks all of our contributors and sponsors for
making Rakudo Perl possible, as well as those people who worked on
the design docs, the Perl 6 test suite, MoarVM and the specification.

The following people contributed to this release:

Jonathan Worthington, Elizabeth Mattijsen, Tobias Leich, skids, Moritz Lenz,
Christian Bartolomäus, Jonathan Scott Duff, Nick Logan, Timo Paulssen,
Carl Mäsak, Steve Mynott, Larry Wall, Rob Hoelz, Jonathan Stowe,
Will "Coke" Coleda, Jimmy Zhuo, Stefan Seifert, Faye Niemeyer, David H. Adler,
Bart Wiegmans, Lucas Buchala, Paul Cochrane, Cédric Vincent, Stéphane Payrard,
Brent Laabs, Daniel Dehennin, Geoff Broadwell, Sue, Sue Spence, smls, ab5tract,
Dmitriy Olshevskiy

If you would like to contribute, see <http://rakudo.org/how-to-help>,
ask on the <perl6-compiler@perl.org> mailing list, or ask on IRC #perl6
on freenode.

The next release of Rakudo (#91), is scheduled for 20 August 2015.
A list of the other planned release dates and code names for future
releases is available in the "docs/release_guide.pod" file. A Rakudo
development release typically occurs a few days (often two) after the
third Tuesday of each month.

The development team appreciates feedback! If you're using Rakudo, do
get back to us. Questions, comments, suggestions for improvements, cool
discoveries, incredible hacks, or any other feedback -- get in touch with
us through (the above-mentioned) mailing list or IRC channel. Enjoy!

[^1]: See <http://moarvm.org/>

[^2]: What's the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Not much more.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, a module installer, the most recent
incarnation of the "Using Perl 6" book, and other software that can
be used with the Rakudo compiler to enhance its utility.  Rakudo Star
is meant for early adopters who wish to explore what's possible with
Rakudo Perl 6 and provide feedback on what works, what doesn't, and
what else they would like to see included in the distribution.
