# Announce: Rakudo Perl 6 compiler, Release #95 (2016.01)

On behalf of the Rakudo development team, I’m very happy to announce the
January 2016 release of Rakudo Perl 6 #95. Rakudo is an implementation of
Perl 6 on the Moar Virtual Machine[^1].

This is the first post-Christmas release of Rakudo Perl 6, and continues
to implement Perl v6.c. It includes bugfixes and optimizations on top of
the 2015.12 release of Rakudo, but no new features.

Thanks to all the individuals, companies, and organizations who donated
money, services, equipment, or their employee's time to the effort.
This includes efforts going back to 2000 over multiple Perl 6 related
projects. As with our developer list on the Christmas release, our
sincere apologies to anyone who was accidentally left off this list.

    * ActiveState
    * BBC
    * Blackstar
    * Booking.com
    * craigslist
    * Richard Dice of Toronto.pm
    * Dijkmat
    * Edument
    * ETH Zürich
    * Google Summer of Code (https://developers.google.com/open-source/gsoc/)
    * Ian Hague
    * Manning Publications
    * Morgan Stanley
    * Mozilla
    * NLNet
    * noris network AG
    * O'Reilly Media
    * Frédéric Schütz of the Swiss Institute of Bioinformatics
    * Stonehenge Consulting
    * The Perl Foundation
    * TPF's Perl 6 Core Development Fund sponsors (http://www.perlfoundation.org/perl_6_core_development_fund)
    * VA Linux
    * WenZPerl
    * Fritz Zaucker of Oetiker+Partner AG

Upcoming releases in 2016 will include new functionality that is not
part of the v6.c specification, available with a lexically scoped
pragma. Our goal is to insure that anything that is tested as part of the
v6.c spec will continue to work unchanged. There may be incremental
spec releases this year as well.

The tarball for this release is available from <http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^2] --- it’s announcing a new release of the compiler
only. For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, but please bear
with us post-Christmas. We are working hard to insure that we don’t break
anything now that we have a released spec, and it make take us a few months
to settle back into a rhythm.

The changes in this release are outlined below:

New in 2016.01:
   + Chained .grep calls on Supply fixed (RT #127297)
   + Fixed interaction with perl6-debug and precompilation that resulted in an
     endless loop
   + re-enabled warning when smart-matching against a True or False literal
   + Fixed internal error when reporting certain type errors (RT #127207)
   + Fixed rare "duplicate definition of symbol" errors (RT #127107)
   + Fixed interpolating of pairs with non-key strings into signatures
   + Fixed error when smart-matching Seq against a Set (RT #127166)
   + Improved error message when smart-matching against an S///-expression
   + Fixed bad interaction between EXPORTHOW and multiple declarations (RT #126566)
   + Fixed various issues regarding precompilation
   + Improved accuracy of Complex.sqrt
   + hyper now preserves order of results, as designed
   + Range.sum on an empty, numeric Range is now 0
   + Fixed Promise.allof() with an empty list of promises (RT #127101)
   + Improved message on premature virtual method call (RT #127097)
   + Better error message for module load failures of types that are part of
     the setting
   + Support for Readline in addition to Linenoise

The following people contributed to this release:

Geoffrey Broadwell, Piers Cawley, Paul Cochrane, Will "Coke" Coleda,
Panu Ervamaa , Lloyd Fournier, Rob Hoelz, Donald Hunter, Dan Kogai,
Tobias Leich, Moritz Lenz, Nick Logan, Dagfinn Ilmari Mannsåker,
Elizabeth Mattijsen, Pawel Murias, Steve Mynott , Anthony Parsons,
Nova Patch, Timo Paulssen, Francois Perrad, Dave Rolsky, Stefan Seifert,
skids, John Spurr, Tommy Stanton, Jonathan Stowe, Larry Wall, David Warring,
Andy Weidenbaum, Bart Wiegmans, Jonathan Worthington, Jimmy Zhuo

as well as

A. Sinan Unur, Aleks-Daniel Jakimenko-Aleksejev, Brad Gilbert, Brian S. Julin, Brock Wilcox, Bruce Gray, Carl Masak, Christian Bartolomäus, Christopher Bottoms, Claudio Ramirez, Dale Evans, Daniel Perrett, Dave Olszewski, David Brunton, Fritz Zaucker, Jake Russo, James ( Jeremy ) Carman, Jeffrey Goff, Jim Davis, John Gabriele, LLFourn, Marcel Timmerman, Martin Dørum Nygaard, Neil Shadrach, Salvador Ortiz, Shlomi Fish, Siavash Askari Nasr, Stéphane Payrard, Sylvain Colinet, Wenzel P. P. Peppmeyer, Zoffix Znet, fireartist, raiph, sylvarant, vinc17fr

If you would like to contribute or find out more information, visit
<http://perl6.org>, <http://rakudo.org/how-to-help>, ask on the
<perl6-compiler@perl.org> mailing list, or ask on IRC #perl6 on freenode.

The next release of Rakudo (#96), is tentatively scheduled for 20 February 2015.

A list of the other planned release dates and code names for future
releases is available in the “docs/release_guide.pod” file.

The development team appreciates feedback! If you’re using Rakudo, do
get back to us. Questions, comments, suggestions for improvements, cool
discoveries, incredible hacks, or any other feedback -- get in touch with
us through (the above-mentioned) mailing list or IRC channel. Enjoy!

Please note that recent releases have known issues running on the JVM.
We are working to get the JVM backend working again but do not yet have
an estimated delivery date.

[^1]: See <http://moarvm.org/>

[^2]: What’s the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Not much more.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, a module installer, the most recent
incarnation of the “Using Perl 6” book, and other software that can
be used with the Rakudo compiler to enhance its utility. Rakudo Star
is meant for early adopters who wish to explore what’s possible with
Rakudo Perl 6 and provide feedback on what works, what doesn’t, and
what else they would like to see included in the distribution.
