# Announce: Rakudo Perl 6 compiler, Release #98 (2016.04)

On behalf of the Rakudo development team, I’m very happy to announce the
April 2016 release of Rakudo Perl 6 #98. Rakudo is an implementation of
Perl 6 on the Moar Virtual Machine[^1].

This release implements the 6.c version of the Perl 6 specifications.
It includes bugfixes and optimizations on top of
the 2015.12 release of Rakudo, but no new features.

Upcoming releases in 2016 will include new functionality that is not
part of the 6.c specification, available with a lexically scoped
pragma. Our goal is to insure that anything that is tested as part of the
6.c specification will continue to work unchanged. There may be incremental
spec releases this year as well.

The tarball for this release is available from <http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^2] --- it’s announcing a new release of the compiler
only. For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The Rakudo Perl compiler follows a monthly release cycle, but please bear
with us post-Christmas. We are working hard to insure that we don’t break
anything now that we have a released spec, and it make take us a few months
to settle back into a rhythm.

The changes in this release are outlined below:

New in 2016.04:
 + Fixes:
   + "magic" inc/dec cleanup
   + utf8-c8 encoding crashes that occurred on random data
   + fix missing pre-comp store unlock
   + missing module error mentions line number
 + Additions:
   + Improved REPL
   + Add :kv to .first
   + Add provisional $*DEFAULT-READ-ELEMS
 + Efficiency:
   + Removed leaks associated with EVAL
   + Speed up .minpairs/.maxpairs
   + Speed up Object:D cmp Object:D
   + Speed up sort 3-15%

These are only some of the changes in this release. For a more
detailed list, see “docs/ChangeLog”.

The following people contributed to this release:

Pawel Murias, Elizabeth Mattijsen, Jonathan Worthington, Timo Paulssen,
Will "Coke" Coleda, Rob Hoelz, Larry Wall, Pepe Schwarz, Moritz Lenz,
Ahmad M. Zawawi, ab5tract, Christian Bartolomäus, Jonathan Scott Duff,
Stefan Seifert, Salve J. Nilsen, 0racle, Steve Mynott, Brad Gilbert,
Nelo Onyiah, Stéphane Payrard, bspecht, skids, Matthew Wilson,
Leon Timmermans, David Warring

as well as

Brian S. Julin, Brock Wilcox, Christopher Bottoms, David H. Adler, Donald Hunter, Emeric54, Itsuki Toyota, Jan-Olof Hendig, John Gabriele, Mathieu Gagnon, Nick Logan, Simon Ruderich, Tom Browder, Wenzel P. P. Peppmeyer, Zoffix Znet

If you would like to contribute or find out more information, visit
<http://perl6.org>, <http://rakudo.org/how-to-help>, ask on the
<perl6-compiler@perl.org> mailing list, or ask on IRC #perl6 on freenode.

The next release of Rakudo (#99), is tentatively scheduled for 21 May 2016.

A list of the other planned release dates is available in the
“docs/release_guide.pod” file.

The development team appreciates feedback! If you’re using Rakudo, do
get back to us. Questions, comments, suggestions for improvements, cool
discoveries, incredible hacks, or any other feedback -- get in touch with
us through (the above-mentioned) mailing list or IRC channel. Enjoy!

Please note that recent releases have known issues running on the JVM.
We are working to get the JVM backend working again but do not yet have
an estimated delivery date.

[^1]: See <http://moarvm.org/>

[^2]: What’s the difference between the Rakudo compiler and the Rakudo
Star distribution?

The Rakudo compiler is a compiler for the Perl 6 language.
Not much more.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, a module installer, the most recent
incarnation of the “Using Perl 6” book, and other software that can
be used with the Rakudo compiler to enhance its utility.
