# Announce: Rakudo Perl 6 compiler, Release 2017.04.2

On behalf of the Rakudo development team, I'm announcing an
out-of-schedule release of the Rakudo Perl 6 compiler.
Rakudo is an implementation of Perl 6 on the Moar Virtual Machine[^1].

This release is a point release in addition to the regular, monthly
releases. This release fixes an issue with method calls on paths in %?RESOURCES
that was introduced in 2017.04 release. The issue impacted installation of several
ecosystem modules. We're currently working on an automated extended testing system that
will prevent such issues from affecting future releases.

The tarball for this release is available from <http://rakudo.org/downloads/rakudo/>.

Please note: This announcement is not for the Rakudo Star
distribution[^2] --- it’s announcing a new release of the compiler
only. For the latest Rakudo Star release, see
<http://rakudo.org/downloads/star/>.

The changes in this release are outlined below:

New in 2017.04.2:
 + Fixes:
    + Fix "Cannot invoke this object (REPR: Null; VMNull)" [4a560aa]
    + Improve relations between %?RESOURCES and Native trait [647abfe]
    + Support all appropriate IO::Path methods on Distribution::Resources [f4f1c42]

The following people contributed to this release:

Stefan Seifert, Zoffix Znet

If you would like to contribute or find out more information, visit
<http://perl6.org>, <http://rakudo.org/how-to-help>, ask on the
<perl6-compiler@perl.org> mailing list, or ask on IRC #perl6 on freenode.

Additionally, we invite you to make a donation to The Perl Foundation
to sponsor Perl 6 development: <https://donate.perlfoundation.org/>
(put "Perl 6 Core Development Fund" in the 'Purpose' text field)

The next release of Rakudo (#111), is tentatively scheduled for 2017-05-20.

A list of the other planned release dates is available in the
“docs/release_guide.pod” file.

The development team appreciates feedback! If you’re using Rakudo, do
get back to us. Questions, comments, suggestions for improvements, cool
discoveries, incredible hacks, or any other feedback -- get in touch with
us through (the above-mentioned) mailing list or IRC channel. Enjoy!

Please note that recent releases have known issues running on the JVM.
We are working to get the JVM backend working again but do not yet have
an estimated delivery date.

[^1]: See <http://moarvm.org/>

[^2]: What’s the difference between the Rakudo compiler and the Rakudo
Star distribution?

[^3]: NQP stands for 'Not Quite Perl', which is a language/environment
that Rakudo is largely written in. See https://github.com/perl6/nqp

The Rakudo compiler is a compiler for the Perl 6 language.
Not much more.

The Rakudo Star distribution is the Rakudo compiler plus a selection
of useful Perl 6 modules, a module installer, the most recent
incarnation of the “Using Perl 6” book, and other software that can
be used with the Rakudo compiler to enhance its utility.

