# Announce: Rakudo compiler, Release 2020.08.1

On behalf of the Rakudo development team, I'm announcing an
out-of-schedule release of the Rakudo compiler.
Rakudo is an implementation of the Raku[^1] language.

This release is a point release in addition to the regular, monthly
releases. This release fixes confusing user facing compiler's version
which occurred with 2020.08 (note: no .1) release.

The tarball for this release is available from <http://rakudo.org/downloads/rakudo/>.
Pre-compiled archives will be available shortly.

The changes in this release are outlined below:

New in 2020.08.1:
  + Changes:
    + Method `invoke` of `WalkList` returns a lazy `Seq` instance now [fe40ee1e]
  + Internal:
    + `Seq` class now has its own proto for `new` method [a19996db]

The following people contributed to this release:

Vadim Belman, Aleks-Daniel Jakimenko-Aleksejev, Elizabeth Mattijsen,
Alexander Kiryuhin

This release implements 6.c and 6.d versions of the Raku specification.
6.c version of the language is available if you use the `use v6.c`
version pragma, otherwise 6.d is the default.

Upcoming releases in 2020 will include new functionality that is not
part of 6.c or 6.d specifications, available with a lexically scoped
pragma. Our goal is to ensure that anything that is tested as part of
6.c and 6.d specifications will continue to work unchanged. There may
be incremental spec releases this year as well.

If you would like to contribute or get more information, visit
<https://raku.org>, <https://rakudo.org/community>, ask on the
<perl6-compiler@perl.org> mailing list, or ask on IRC #raku on freenode.

Additionally, we invite you to make a donation to The Perl Foundation
to sponsor Raku development: <https://donate.perlfoundation.org/>
(put “Raku Core Development Fund” in the ‘Purpose’ text field)

The next release of Rakudo (#139), is tentatively scheduled for 2020-09-19.

A list of the other planned release dates is available in the
“docs/release_guide.pod” file.

The development team appreciates feedback! If you’re using Rakudo, do
get back to us. Questions, comments, suggestions for improvements, cool
discoveries, incredible hacks, or any other feedback -- get in touch with
us through (the above-mentioned) mailing list or IRC channel. Enjoy!

Please note that recent releases have known issues running on the JVM.
We are working to get the JVM backend working again but do not yet have
an estimated delivery date.

[^1]: See <https://raku.org/>
